import { transformSchemaAST } from "@graphql-codegen/schema-ast";
import { YupSchemaVisitor } from "./yup/index";
import { oldVisit, } from "@graphql-codegen/plugin-helpers";
export const plugin = (schema, _documents, config) => {
    const { schema: _schema, ast } = transformSchemaAST(schema, config);
    const { buildImports, ...visitor } = YupSchemaVisitor(_schema, config);
    const result = oldVisit(ast, {
        leave: visitor,
    });
    // @ts-ignore
    const generated = result.definitions.filter((def) => typeof def === "string");
    return {
        prepend: buildImports(),
        content: "\n" + [...generated].join("\n"),
    };
};
